Signed-off-by: David Wu <davidwu@arcturusnetworks.com>
diff -urNa u-boot-2009.11/cpu/mcf52x2/start.S u-boot-2009.11-patched/cpu/mcf52x2/start.S
--- u-boot-2009.11/cpu/mcf52x2/start.S	2009-12-15 17:20:54.000000000 -0500
+++ u-boot-2009.11-patched/cpu/mcf52x2/start.S	2009-12-31 13:09:41.000000000 -0500
@@ -417,7 +417,10 @@
 	movec	%d0, %ACR0			/* Enable cache */
 	move.l	#0xff00c000, %d0		/* Setup cache mask */
 	movec	%d0, %ACR1			/* Enable cache */
-	move.l	#0x80400100, %d0		/* Setup cache mask, data cache disabel*/
+	move.l	#0x80400000, %d0		/* Setup cache mask, data cache disabled, 
+						   bit 5 set to 0 per chip errata
+						   (MCF5282DE, Rev. 6, 5/2009)
+						 */
 	movec	%d0, %CACR			/* Enable cache */
 	moveq	#1, %d0
 icache_state_access_1:
diff -urNa u-boot-2009.11/cpu/mcf52x2/cpu_init.c u-boot-2009.11-patched/cpu/mcf52x2/cpu_init.c
--- u-boot-2009.11/cpu/mcf52x2/cpu_init.c	2009-12-15 17:20:54.000000000 -0500
+++ u-boot-2009.11-patched/cpu/mcf52x2/cpu_init.c	2010-01-08 14:32:43.000000000 -0500
@@ -598,8 +598,10 @@
 
 #endif				/* CONFIG_MONITOR_IS_IN_RAM */
 
-	/* defer enabling cache until boot (see do_go) */
-	/* icache_enable(); */
+#if defined(CONFIG_SYS_ENABLE_ICACHE)
+	/* enable instruction cache now */
+	icache_enable();
+#endif
 }
 
 /*
